<?php
require_once 'python.php';

$list = python::run();
if (!empty($_POST['pid'])) {
    $status = python::kill($_POST['pid']);

    if ($status) {
        echo 1;exit;
    }
    echo 2;exit;
}

$head = array_shift($list);
?>



<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>PHP-FPM 监控页</title>
    <style>
    body,html{margin:0;padding:0;background: #f1f2f7; font-family: "微软雅黑";font-size: 16px;}
    .card-header {padding: .75rem 1.25rem;margin-bottom: 0;background-color: #fff;border-bottom: 1px solid rgba(0,0,0,.125);width:100%;}
    .card-title {margin-bottom: .75rem;}
    .table {width: 100%;margin-bottom: 1rem;background-color: transparent;}
    .table td {color: #343a40;font-size: 14px;font-weight: 600;vertical-align: middle;}
    .table th, .table td {border: none;border-bottom: 1px solid #e8e9ef;color: #868e96;font-size: 12px;font-weight: normal;padding: .75em 1.25em;}
    .header{width: 400px;text-align: left;}
    .header th{background: #fff;border-color: #fff;width: 170px;}
    .content td, .content th{text-align: left;}
    .content td{background:#fff}
    .badge-complete {background: #00c292;}
    .badge {display: inline-block;padding: 10PX;font-size:13px; line-height: 1;text-align: center;white-space: nowrap;vertical-align: baseline;border-radius: .25rem;text-decoration: none;}
    </style>
    <script src="http://www.jq22.com/jquery/jquery-1.10.2.js"></script>

</head>
<body>

<div>
    <div class="card-header">
        <strong class="card-title">PHP-FPM 说明</strong>
    </div>
    <table class="table header">
        <tr><th>进程池名称：</th><td><?php echo $head['pool'];?></td></tr>
        <tr><th>进程管理方式：</th><td><?php echo $head['process_manager'];?></td></tr>
        <tr><th>启动日期：</th><td><?php echo $head['start_time'];?></td></tr>
        <tr><th>运行时长：</th><td><?php echo python::getDate($head['start_since']);?></td></tr>
        <tr><th>当前进程池接受的请求数：</th><td><?php echo $head['accepted_conn'];?></td></tr>
        <tr><th>请求等待队列：</th><td><?php echo $head['listen_queue'];?></td></tr>
        <tr><th>等待队列峰值：</th><td><?php echo $head['max_listen_queue'];?></td></tr>
        <tr><th>socket等待队列长度：</th><td><?php echo $head['listen_queue_len'];?></td></tr>
        <tr><th>空闲进程数量：</th><td><?php echo $head['idle_processes'];?></td></tr>
        <tr><th>活跃进程数量：</th><td><?php echo $head['active_processes'];?></td></tr>
        <tr><th>总进程数量：</th><td><?php echo $head['total_processes'];?></td></tr>
        <tr><th>最大的活跃进程数量：</th><td><?php echo $head['max_active_processes'];?></td></tr>
        <tr><th>达到进程最大数量限制的次数：</th><td><?php echo $head['max_children_reached'];?></td></tr>
        <tr><th>缓慢请求的数量：</th><td><?php echo $head['slow_requests'];?></td></tr>
    </table>
</div>


<div>
    <div class="card-header">
        <strong class="card-title">进程列表</strong>
    </div>
    <table class="table content">
        <tr>
            <th>进程ID</th>
            <th>状态</th>
            <th>进程启动日期</th>
            <th>进程运行时长</th>
            <th>请求方法</th>
            <th>请求地址</th>
            <th>来源IP</th>
            <th>用户</th>
            <th>PHP脚本</th>
            <th> 最后一个请求CPU使用率(单核)</th>
            <th>上一个请求使用的内存</th>
            <th>操作</th>
        </tr>
        <?php foreach ($list as $k=>$v) { ?>
        <tr id="del-<?php echo $v['pid'];?>">
            <td><?php echo $v['pid'];?></td>
            <td><?php echo $v['state'];?></td>
            <td><?php echo $v['start_time'];?></td>
            <td><?php echo python::getDate($v['start_since']);?></td>
            <td><?php echo $v['request_method'];?></td>
            <td><?php echo $v['request_URI'];?></td>
            <td><?php echo $v['ip'];?></td>
            <td><?php echo $v['user'];?></td>
            <td><?php echo $v['script'];?></td>
            <td><?php echo $v['last_request_cpu'];?>%</td>
            <td><?php echo $v['last_request_memory'];?></td>
            <td>
                <a href='javascript:del("<?php echo $v['pid'];?>");' class="badge badge-complete" style="color:#fff">杀死进程</a>
            </td>
        </tr>
        <?php } ?>
    </table>
</div>

<script>
function del(pid) {
    $.ajax({
        type: 'post',
        data: {'pid':pid},
        url: "/index.php",
        success: function(data) {
          if (data == 1) {
            alert('杀死成功');
            $('#del-'+pid).remove();
          } else {
              alert('杀死失败');
          }
      }
    });
}
</script>
</body>
</html>