<?php
// +----------------------------------------------------------------------
// | 抓取PHP-FPM status
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------
class python {
    /*
     * PHP-FPM的监控地址
    */
    private static $url = 'http://你的域名或IP/status?full';
    /*
     * 结果集
    */
    private static $list = [];
    /*
     * 请求所携带的域名，自动识别
    */
    private static $domain;
    /*
     * 进程对应的IP地址
    */
    private static $ip = [];
    
    /**
     * 微信接口数据传输的万能函数
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @param string $url 请求地址
     * @param mixed $dea 请求头，默认为空
     * @return mixed 请求返回内容
    */
	private static function https_curl($url, $head = null){
		$curl = curl_init();

		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);

		if (!empty($head)){
            curl_setopt($curl, CURLOPT_HTTPHEADER, $head);
		}

		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$response = curl_exec($curl);
		curl_close($curl);
		return $response;
    }

    /**
     * 开始抓取
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
    public static function run() {
        self::OS();
        self::$domain = self::getUrl();
        
        $res = self::https_curl(self::$url);
        $array = explode('************************', $res);

        foreach ($array as $k=>$v) {
            // 处理内容
            self::main($v);
        }
        
        return self::$list;
    }

    /**
     * 杀死子进程
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @param string $pid 子进程ID
     * @return string
    */
    public static function kill($pid) {
        if (function_exists('exec') == false) return false;
        
        exec('kill -9 '.$pid, $retval, $status);
        if ($status == 0) return true;
        
        return false;
    }

    /**
     * 秒转天数
     * @todo 无
     * @author 小黄牛
     * @version v1.1.8 + 2019.04.01
     * @deprecated 暂不弃用
     * @global 无
     * @param int $time
     * @return void
    */
    public static function getDate($time) {
        $d = floor($time / (3600*24));
        $h = floor(($time % (3600*24)) / 3600);
        $m = floor((($time % (3600*24)) % 3600) / 60);
        if ($d>'0') {
            return $d.'天'.$h.'小时'.$m.'分';
        } else {
            if ($h!='0') {
                return $h.'小时'.$m.'分';
            } else {
                return $m.'分';
            }
        }
    }

    /**
     * 处理内容
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @param string $string
     * @return void
    */
    private static function main($string) {
        $array = explode("\n", $string);
        $list = [];
        foreach ($array as $k=>$v) {
            if (empty($v)) continue;
            
            if (stripos($v, 'start time:') !== false) {
                $v = ltrim($v, 'start time:');
                $v = explode(' ', $v);
                $v = $v[0];
                $v = explode(':', $v);
                $date = self::getTime($v);
                $list['start_time'] = $date;
            } else {
                $v = explode(':', $v);
                $key = str_replace(' ', '_', $v[0]);
                $content = str_replace(' ', '', $v[1]);
                switch ($content) {
                    case 'Running'; $content = '接收'; break;
                    case 'Idle'; $content = '空闲'; break;
                }
                if ($key == 'request_URI' && stripos($content, '//') === false) {
                    $content = self::$domain.$content;
                } else if ($key == 'last_request_memory') {
                    $content = self::formatsize($content);
                } else if ($key == 'pid') {
                    $list['ip'] = self::getIp($content);
                }
                
                $list[$key] = $content;
            }
        }
        self::$list[] = $list;
    }

    /**
     * linux的日期转换
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @param string $date
     * @return string
    */
    private static function getTime($date) {
        $arr = array_reverse(explode('/', $date[0]));

        if ($arr[1] == 'Sept') {
            $arr[1] = '08';
        } else {
            $vif = [
                'Jan'=>'01',
                'Feb'=>'02',
                'Mar'=>'03',
                'Apr'=>'04',
                'May'=>'05',
                'Jun'=>'06',
                'Jul'=>'07',
                'Aug'=>'08',
                'Sep'=>'09',
                'Oct'=>'10',
                'Nov'=>'11',
                'Dec'=>'12',
            ];
            if (!isset($vif[$arr[1]])) die('没有收录到该日期关键词：'.$arr[1]);
            $arr[1] = $vif[$arr[1]];
        }

        return $arr[0].'-'.$arr[1].'-'.$arr[2].' '.$date[1].':'.$date[2].':'.$date[3];
    }

    /**
     * 判断是否Linux环境
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @return bool
    */
    private static function OS(){
        if (DIRECTORY_SEPARATOR != '/') die('只能在linux环境下运行');
    }

    /**
     * 判断是否SSL协议
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @return string
    */
    private static function getUrl() {
        $url = $_SERVER['HTTP_HOST'];
        if (stripos($url, '//') !== false) return $url;

        if (isset($_SERVER['HTTPS']) && ('1' == $_SERVER['HTTPS'] || 'on' == strtolower($_SERVER['HTTPS']))) {
            return 'https://'.$url;
        } elseif(isset($_SERVER['SERVER_PORT']) && ('443' == $_SERVER['SERVER_PORT'] )) {
            return 'https://'.$url;
        }
        return 'http://'.$url;
    }

    /**
     * 内存单位转换
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @param int $size 内存数
     * @return int
    */
    private static function formatsize($size) {
        $units = array(' B', ' KB', ' MB', ' GB', ' TB'); 
        for ($i = 0; $size >= 1024 && $i < 4; $i++) $size /= 1024; 
        return round($size, 2).$units[$i]; 
    }

    /**
     * 获取来源IP
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1
     * @deprecated 暂不弃用
     * @global 无
     * @param string $pid 子进程ID
     * @return string
    */
    private static function getIp($pid) {
        if (function_exists('exec') == false) return false;
        
        if (count(self::$ip) <= 0) {
            exec('netstat -np', $retval, $status);
            if ($status == 0) {
                $list = [];
                foreach ($retval as $k=>$v) {
                    $v = preg_replace ( "/\s(?=\s)/","\\1", $v);
                    $arr = explode(' ', $v);
                    // 这里只保留了TCP的进程信息，其他进程信息也需要的话，自行扩展
                    $in_array = [
                        'tcp', 'tcp6', 'upd', 'upd6'
                    ];

                    if (in_array($arr[0], $in_array)) {
                        // 里面是为了拿到进程号
                        $array = explode('/', $arr[6]);
                        if (count($array) > 1) {
                            $list[$array[0]] = $arr[4];
                        }
                    }
                }
            }

            $list2 = [];
            # 同为php-fpm是没权限的，所以需要查询父进程
            exec('ps -eo user,pid,ppid,c,stime,time,size,rss,nice,stat,cmd', $retval2, $status2);
            if ($status2 == 0) {
                foreach ($retval2 as $k => $v) {
                    $v = preg_replace ( "/\s(?=\s)/","\\1", $v);
                    $arr = explode(' ', $v);
                    if (stripos($v, 'netstat -nao') !== false) {
                        $pid = $arr[2];
                        $ppid = $arr[1];
                        if (!empty($list[$ppid])) {
                            $list2[$pid] = $list[$ppid];
                        }
                    }
                }
            }

            self::$ip = $list2;
        }

        return self::$ip[$pid];
    }
}